package com.benyanyi.okhttp.download;

import android.content.Context;

import com.benyanyi.okhttp.listener.OnDownLoadObserver;

/**
 * @author YanYi
 * @date 2019-08-15 10:23
 * @email ben@yanyi.red
 * @overview
 */
public class DownloadCall implements DownloadConfig {

    private Context mContext;
    private String url;

    private DownloadCall(Builder builder) {
        this.mContext = builder.mContext;
        this.url = builder.url;
    }

    @Override
    public void start(OnDownLoadObserver onDownLoadObserver) {
        DownloadManager.getInstance(mContext).download(url, onDownLoadObserver);
    }

    @Override
    public void start(String suffix, OnDownLoadObserver onDownLoadObserver) {
        DownloadManager.getInstance(mContext).download(url, suffix, onDownLoadObserver);
    }

    @Override
    public void cancel() {
        DownloadManager.getInstance(mContext).cancel(url);
    }

    public static class Builder {

        private Context mContext;
        private String url;

        public Builder setContext(Context mContext) {
            this.mContext = mContext;
            return this;
        }

        public Builder setUrl(String url) {
            this.url = url;
            return this;
        }

        public DownloadConfig builder() {
            return new DownloadCall(this);
        }

    }

}
